***********************************************************************
This is the consumer durable module for the ECV 1995 dataset.

Merge between the permanent minimum household ID dataset (NHID) and the
vivienda module. Then should do frequency test (with table statement)
which is deleted in this version.

Program then assigns missing values to the non-recording ones (888 etc.)
for age and value of the consumer durables.  Had to drop the goods
223 and 24 because they were 'other' and not more closely specified.

Programs calculates average age and average value of the good (once
again interpreting the question 5 as the replacement value (new) --
something which is debatable.  For all '0' or '.' entries in age and
value (although the household reports having the good) averages of the
whole sample are used.

Finally, the welfare from the stock of consumer durables is defined
as: the sum of the individual components, valuing ONE good at the given
replacement value and all other goods per houshold at the average value.
This sum is then devided by the average age of the good time 2 (should
be the lifespan given equal distribution over time) times 12
months.  This should give the monthly consumer durable use.

Proq Freq ends the procedure.


***********************************************************************

;
options nocenter;
options linesize=70;
options obs=max;

;

libname saslib95 'c:\eclsms\data\saslib95';

data work0;
        set saslib95.e95vi10;

proc sort; by nhid1 nhid2;

data nhid;
        set saslib95.nhid;
        id=1;
        keep nhid1 nhid2 id;

proc sort; by nhid1 nhid2;

data merge;
        merge work0 nhid;
        if id=. then delete;
;
data work0;
  set merge;
  if vi36014>87 then vi36014=.;
  if vi36024>87 then vi36024=.;
  if vi36034>87 then vi36034=.;
  if vi36044>87 then vi36044=.;
  if vi36054>87 then vi36054=.;
  if vi36064>87 then vi36064=.;
  if vi36074>87 then vi36074=.;
  if vi36084>87 then vi36084=.;
  if vi36094>87 then vi36094=.;
  if vi36104>87 then vi36104=.;
  if vi36114>87 then vi36114=.;
  if vi36124>87 then vi36124=.;
  if vi36134>87 then vi36134=.;
  if vi36144>87 then vi36144=.;
  if vi36154>87 then vi36154=.;
  if vi36164>87 then vi36164=.;
  if vi36174>87 then vi36174=.;
  if vi36184>87 then vi36184=.;
  if vi36194>87 then vi36194=.;
  if vi36204>87 then vi36204=.;
  if vi36214>87 then vi36214=.;
  if vi36224>87 then vi36224=.;
  if vi36234>87 then vi36234=.;
  if vi36244>87 then vi36244=.;
;

  if vi36015>88888887 or vi36015=0 then vi36015=.;
  if vi36025>88888887 or vi36025=0 then vi36025=.;
  if vi36035>88888887 or vi36035=0 then vi36035=.;
  if vi36045>88888887 or vi36045=0 then vi36045=.;
  if vi36055>88888887 or vi36055=0 then vi36055=.;
  if vi36065>88888887 or vi36065=0 then vi36065=.;
  if vi36075>88888887 or vi36075=0 then vi36075=.;
  if vi36085>88888887 or vi36085=0 then vi36085=.;
  if vi36095>88888887 or vi36095=0 then vi36095=.;
  if vi36105>88888887 or vi36105=0 then vi36105=.;
  if vi36115>88888887 or vi36115=0 then vi36115=.;
  if vi36125>88888887 or vi36125=0 then vi36125=.;
  if vi36135>88888887 or vi36135=0 then vi36135=.;
  if vi36145>88888887 or vi36145=0 then vi36145=.;
  if vi36155>888888887 or vi36155=0 then vi36155=.;
  if vi36165>88888887 or vi36165=0 then vi36165=.;
  if vi36175>88888887 or vi36175=0 then vi36175=.;
  if vi36185>88888887 or vi36185=0 then vi36185=.;
  if vi36195>88888887 or vi36195=0 then vi36195=.;
  if vi36205>88888887 or vi36205=0 then vi36205=.;
  if vi36215>88888887 or vi36215=0 then vi35215=.;
  if vi36225>88888887 or vi36225=0 then vi35225=.;

  con=1;

  proc means data=work0 noprint;
    var vi36015
        vi36025
        vi36035
        vi36045
        vi36055
        vi36065
        vi36075
        vi36085
        vi36095
        vi36105
        vi36115
        vi36125
        vi36135
        vi36145
        vi36155
        vi36165
        vi36175
        vi36185
        vi36195
        vi36205
        vi36215
        vi36225

        vi36014
        vi36024
        vi36034
        vi36044
        vi36054
        vi36064
        vi36074
        vi36084
        vi36094
        vi36104
        vi36114
        vi36124
        vi36134
        vi36144
        vi36154
        vi36164
        vi36174
        vi36184
        vi36194
        vi36204
        vi36214
        vi36224 con;

    output out=means mean=
        a36015
        a36025
        a36035
        a36045
        a36055
        a36065
        a36075
        a36085
        a36095
        a36105
        a36115
        a36125
        a36135
        a36145
        a36155
        a36165
        a36175
        a36185
        a36195
        a36205
        a36215
        a36225

        a36014
        a36024
        a36034
        a36044
        a36054
        a36064
        a36074
        a36084
        a36094
        a36104
        a36114
        a36124
        a36134
        a36144
        a36154
        a36164
        a36174
        a36184
        a36194
        a36204
        a36214
        a36224 con;

  data work2;
    merge work0 means; by con;
    if vi36012=1 and (vi36015=0 or vi36015=.) then vi36015=a36015;
    if vi36022=1 and (vi36025=0 or vi36025=.) then vi36025=a36025;
    if vi36032=1 and (vi36035=0 or vi36035=.) then vi36035=a36035;
    if vi36042=1 and (vi36045=0 or vi36045=.) then vi36045=a36045;
    if vi36052=1 and (vi36055=0 or vi36055=.) then vi36055=a36055;
    if vi36062=1 and (vi36065=0 or vi36065=.) then vi36075=a36065;
    if vi36072=1 and (vi36075=0 or vi36075=.) then vi36075=a36075;
    if vi36082=1 and (vi36085=0 or vi36085=.) then vi36085=a36085;
    if vi36092=1 and (vi36095=0 or vi36095=.) then vi36095=a36095;
    if vi36102=1 and (vi36105=0 or vi36105=.) then vi36105=a36105;
    if vi36112=1 and (vi36115=0 or vi36115=.) then vi36115=a36115;
    if vi36122=1 and (vi36125=0 or vi36125=.) then vi36125=a36125;
    if vi36132=1 and (vi36135=0 or vi36135=.) then vi36135=a36135;
    if vi36142=1 and (vi36145=0 or vi36145=.) then vi36145=a36145;
    if vi36152=1 and (vi36155=0 or vi36155=.) then vi36155=a36155;
    if vi36162=1 and (vi36165=0 or vi36165=.) then vi36165=a36165;
    if vi36172=1 and (vi36175=0 or vi36175=.) then vi36175=a36175;
    if vi36182=1 and (vi36185=0 or vi36185=.) then vi36185=a36185;
    if vi36192=1 and (vi36195=0 or vi36195=.) then vi36195=a36195;
    if vi36202=1 and (vi36205=0 or vi36205=.) then vi36205=a36205;
    if vi36212=1 and (vi36215=0 or vi36215=.) then vi36215=a36215;
    if vi36222=1 and (vi36225=0 or vi36225=.) then vi36225=a36225;

     if vi36013=0 then vi36013=1;
     if vi36023=0 then vi36023=1;
     if vi36033=0 then vi36033=1;
     if vi36043=0 then vi36043=1;
     if vi36053=0 then vi36053=1;
     if vi36063=0 then vi36063=1;
     if vi36073=0 then vi36073=1;
     if vi36083=0 then vi36083=1;
     if vi36093=0 then vi36093=1;
     if vi36103=0 then vi36103=1;
     if vi36113=0 then vi36113=1;
     if vi36123=0 then vi36123=1;
     if vi36133=0 then vi36133=1;
     if vi36143=0 then vi36143=1;
     if vi36153=0 then vi36153=1;
     if vi36163=0 then vi36163=1;
     if vi36173=0 then vi36173=1;
     if vi36183=0 then vi36183=1;
     if vi36193=0 then vi36193=1;
     if vi36203=0 then vi36203=1;
     if vi36213=0 then vi36213=1;
     if vi36223=0 then vi36223=1;

    cons01=(vi36015+(vi36013-1)*a36015)/(24*a36014);
    cons02=(vi36025+(vi36023-1)*a36025)/(24*a36024);
    cons03=(vi36035+(vi36033-1)*a36035)/(24*a36034);
    cons04=(vi36045+(vi36043-1)*a36045)/(24*a36044);
    cons05=(vi36055+(vi36053-1)*a36055)/(24*a36054);
    cons06=(vi36065+(vi36063-1)*a36065)/(24*a36064);
    cons07=(vi36075+(vi36073-1)*a36075)/(24*a36074);
    cons08=(vi36085+(vi36083-1)*a36085)/(24*a36084);
    cons09=(vi36095+(vi36093-1)*a36095)/(24*a36094);
    cons10=(vi36105+(vi36103-1)*a36105)/(24*a36104);
    cons11=(vi36115+(vi36113-1)*a36115)/(24*a36114);
    cons12=(vi36125+(vi36123-1)*a36125)/(24*a36124);
    cons13=(vi36135+(vi36133-1)*a36135)/(24*a36134);
    cons14=(vi36145+(vi36143-1)*a36145)/(24*a36144);
    cons15=(vi36155+(vi36153-1)*a36155)/(24*a36154);
    cons16=(vi36165+(vi36163-1)*a36165)/(24*a36164);
    cons17=(vi36175+(vi36173-1)*a36175)/(24*a36174);
    cons18=(vi36185+(vi36183-1)*a36185)/(24*a36184);
    cons19=(vi36195+(vi36193-1)*a36195)/(24*a36194);
    cons20=(vi36205+(vi36203-1)*a36205)/(24*a36204);
    cons21=(vi36215+(vi36213-1)*a36215)/(24*a36214);
    cons22=(vi36225+(vi36223-1)*a36225)/(24*a36224);

    durcon=sum(cons01,cons02,cons03,cons04,cons05,cons06,
               cons07,cons08,cons09,cons10,cons11,cons12,
               cons13,cons14,cons15,cons16,cons17,cons18,
               cons19,cons20,cons21,cons21);

    if durcon=. then durcon=0; run;

data outcon;
    set work2;
    keep nhid1 nhid2 durcon;

proc freq;
        tables durcon;

data saslib95.durcon;
        set outcon;


run;
quit;
