***********************************************************************
This is the housing file for the ECV 1995 dataset.

First splicing datasets together and looking at frequency distribution

Water expenditure is not included because it might be a misleading
indicator of wealth (because people have different access to water
and the nominal expenditure might be a quite noisy measure of the
actual welfare derived from water consumption).  Also, we do not
include any other measure of expenditures as we could have double
counting in the imputation regresssion.

The consumer durables variable tries to calculate the actual value of
consumer durables left (accoutning for the depreciation to date.


***********************************************************************
;
/*;
options nocenter;
options linesize=80;
options obs=max;

libname saslib95 'c:\eclsms\data\saslib95';

data work0a;
        set saslib95.e95vi10;

proc sort; by nhid1 nhid2;

data work0b;
        set saslib95.durcon;

proc sort; by nhid1 nhid2;

data nhid;
        set saslib95.nhid;
        id=1;
        keep nhid1 nhid2 id;

proc sort; by nhid1 nhid2;
;
data merge;
        merge work0a nhid work0b;
        if id=. then delete;
;
data work;
        set merge;

  house=0;
  if vi02=1 then house=1;

  appart=0;
  if vi02=2 then appart=1;

  room=0;
  if vi02=3 then room=1;

  stonwal=0;
  if vi03=1 then stonwal=1;

  adobwal=0;
  if vi03=2 then adobwal=1;

  woodwal=0;
  if vi03=3 then woodwal=1;

  plnkflor=0;
  if vi04=1 then plnkflor=1;

  parqflor=0;
  if vi04=2 then parqflor=1;

  baldflor=0;
  if vi04=3 then baldflor=1;

  vnylflor=0;
  if vi04=4 then vnylflor=1;

  cmntflor=0;
  if vi04=5 then cmntflor=1;

  caneflor=0;
  if vi04=5 then caneflor=1;

  numrooms=vi05a;

  bedrooms=vi06;

  bathroom=vi07a;

  kitchen=0;
  if vi08=1 then kitchen=1;

  ownkit=0;
  if vi09=1 then ownkit=1;

  watpub=0;
  if (vi10=1 or vi10=2) then watpub=1;

  wattub=0;
  if vi10=3 then wattub=1;

  watlav=0;
  if vi10=4 then watlav=1;

  wattru=0;
  if vi10=5 then wattru=1;

  permin=vi13b/60;
     if permin=. then permin=0;
     timewat=vi13a+permin;
     if timewat=. then timewat=0;

  sewage=0;
  if vi17=1 then sewage=1;

  septic=0;
  if vi17=2 then septic=1;

  electric=0;
  if (vi20=1 or vi20=2) then electric=1;

  expelec=vi22;
            if expelec>999997 then expelec=.;
            if expelec=. then expelec=0;

  expcand=vi23;
            if expcand>999997 then expcand=.;
            if expcand=. then expcand=0;

  phone=0;
            if vi24=1 then phone=1;

  exppho=vi26;
            if exppho>999997 then exppho=.;
            if exppho=. then exppho=0;

  shower=0;
  if vi27=1 then shower=1;

  wastdisp=0;
  if (vi27=1 or vi27=2) then wastdisp=1;

  wastyes=0;
  if (vi29=1 or vi29=2) then wastyes=1;

  cookgas=0;
  if vi30=1 then cookgas=1;

  cooklena=0;
  if vi30=1 then cooklena=1;

  cookcar=0;
  if vi30=1 then cookcar=1;

  cookelec=0;
  if vi30=1 then cookelec=1;


  expcook=vi31;
         if expcook>999997 then expcook=.;
         if expcook=. then expcook=0;

  if vi33>8888887 then vi33=.;
  if vi34>8888887 then vi34=.;

  rent=vi33;
        if vi34 ne '.' then rent=vi34;

        if rent=0 then rent=.;
        if rent>8888887 then rent=.;


  narea=0;
        if area=1 then narea=1;
        if (area=2 or area=3 or area=4) then narea=2;

  *******************  consumer durables;
  if vi36014>87 then vi36014=.;
  if vi36024>87 then vi36024=.;
  if vi36034>87 then vi36034=.;
  if vi36044>87 then vi36044=.;
  if vi36054>87 then vi36054=.;
  if vi36064>87 then vi36064=.;
  if vi36074>87 then vi36074=.;
  if vi36084>87 then vi36084=.;
  if vi36094>87 then vi36094=.;
  if vi36104>87 then vi36104=.;
  if vi36114>87 then vi36114=.;
  if vi36124>87 then vi36124=.;
  if vi36134>87 then vi36134=.;
  if vi36144>87 then vi36144=.;
  if vi36154>87 then vi36154=.;
  if vi36164>87 then vi36164=.;
  if vi36174>87 then vi36174=.;
  if vi36184>87 then vi36184=.;
  if vi36194>87 then vi36194=.;
  if vi36204>87 then vi36204=.;
  if vi36214>87 then vi36214=.;
  if vi36224>87 then vi36224=.;
  if vi36234>87 then vi36234=.;
  if vi36244>87 then vi36244=.;
;

  if vi36015>88888887 or vi36015=0 then vi36015=.;
  if vi36025>88888887 or vi36025=0 then vi36025=.;
  if vi36035>88888887 or vi36035=0 then vi36035=.;
  if vi36045>88888887 or vi36045=0 then vi36045=.;
  if vi36055>88888887 or vi36055=0 then vi36055=.;
  if vi36065>88888887 or vi36065=0 then vi36065=.;
  if vi36075>88888887 or vi36075=0 then vi36075=.;
  if vi36085>88888887 or vi36085=0 then vi36085=.;
  if vi36095>88888887 or vi36095=0 then vi36095=.;
  if vi36105>88888887 or vi36105=0 then vi36105=.;
  if vi36115>88888887 or vi36115=0 then vi36115=.;
  if vi36125>88888887 or vi36125=0 then vi36125=.;
  if vi36135>88888887 or vi36135=0 then vi36135=.;
  if vi36145>88888887 or vi36145=0 then vi36145=.;
  if vi36155>888888887 or vi36155=0 then vi36155=.;
  if vi36165>88888887 or vi36165=0 then vi36165=.;
  if vi36175>88888887 or vi36175=0 then vi36175=.;
  if vi36185>88888887 or vi36185=0 then vi36185=.;
  if vi36195>88888887 or vi36195=0 then vi36195=.;
  if vi36205>88888887 or vi36205=0 then vi36205=.;
  if vi36215>88888887 or vi36215=0 then vi35215=.;
  if vi36225>88888887 or vi36225=0 then vi35225=.;

  con=1;

proc means data=work noprint;
    var vi36015
        vi36025
        vi36035
        vi36045
        vi36055
        vi36065
        vi36075
        vi36085
        vi36095
        vi36105
        vi36115
        vi36125
        vi36135
        vi36145
        vi36155
        vi36165
        vi36175
        vi36185
        vi36195
        vi36205
        vi36215
        vi36225

        vi36014
        vi36024
        vi36034
        vi36044
        vi36054
        vi36064
        vi36074
        vi36084
        vi36094
        vi36104
        vi36114
        vi36124
        vi36134
        vi36144
        vi36154
        vi36164
        vi36174
        vi36184
        vi36194
        vi36204
        vi36214
        vi36224 con;

    output out=means mean=
        a36015
        a36025
        a36035
        a36045
        a36055
        a36065
        a36075
        a36085
        a36095
        a36105
        a36115
        a36125
        a36135
        a36145
        a36155
        a36165
        a36175
        a36185
        a36195
        a36205
        a36215
        a36225

        a36014
        a36024
        a36034
        a36044
        a36054
        a36064
        a36074
        a36084
        a36094
        a36104
        a36114
        a36124
        a36134
        a36144
        a36154
        a36164
        a36174
        a36184
        a36194
        a36204
        a36214
        a36224 con;
;
  data work2;
        merge work means;
        by con;

    if vi36012=1 and (vi36015=0 or vi36015=.) then vi36015=a36015;
    if vi36022=1 and (vi36025=0 or vi36025=.) then vi36025=a36025;
    if vi36032=1 and (vi36035=0 or vi36035=.) then vi36035=a36035;
    if vi36042=1 and (vi36045=0 or vi36045=.) then vi36045=a36045;
    if vi36052=1 and (vi36055=0 or vi36055=.) then vi36055=a36055;
    if vi36062=1 and (vi36065=0 or vi36065=.) then vi36075=a36065;
    if vi36072=1 and (vi36075=0 or vi36075=.) then vi36075=a36075;
    if vi36082=1 and (vi36085=0 or vi36085=.) then vi36085=a36085;
    if vi36092=1 and (vi36095=0 or vi36095=.) then vi36095=a36095;
    if vi36102=1 and (vi36105=0 or vi36105=.) then vi36105=a36105;
    if vi36112=1 and (vi36115=0 or vi36115=.) then vi36115=a36115;
    if vi36122=1 and (vi36125=0 or vi36125=.) then vi36125=a36125;
    if vi36132=1 and (vi36135=0 or vi36135=.) then vi36135=a36135;
    if vi36142=1 and (vi36145=0 or vi36145=.) then vi36145=a36145;
    if vi36152=1 and (vi36155=0 or vi36155=.) then vi36155=a36155;
    if vi36162=1 and (vi36165=0 or vi36165=.) then vi36165=a36165;
    if vi36172=1 and (vi36175=0 or vi36175=.) then vi36175=a36175;
    if vi36182=1 and (vi36185=0 or vi36185=.) then vi36185=a36185;
    if vi36192=1 and (vi36195=0 or vi36195=.) then vi36195=a36195;
    if vi36202=1 and (vi36205=0 or vi36205=.) then vi36205=a36205;
    if vi36212=1 and (vi36215=0 or vi36215=.) then vi36215=a36215;
    if vi36222=1 and (vi36225=0 or vi36225=.) then vi36225=a36225;

     if vi36013=0 then vi36013=1;
     if vi36023=0 then vi36023=1;
     if vi36033=0 then vi36033=1;
     if vi36043=0 then vi36043=1;
     if vi36053=0 then vi36053=1;
     if vi36063=0 then vi36063=1;
     if vi36073=0 then vi36073=1;
     if vi36083=0 then vi36083=1;
     if vi36093=0 then vi36093=1;
     if vi36103=0 then vi36103=1;
     if vi36113=0 then vi36113=1;
     if vi36123=0 then vi36123=1;
     if vi36133=0 then vi36133=1;
     if vi36143=0 then vi36143=1;
     if vi36153=0 then vi36153=1;
     if vi36163=0 then vi36163=1;
     if vi36173=0 then vi36173=1;
     if vi36183=0 then vi36183=1;
     if vi36193=0 then vi36193=1;
     if vi36203=0 then vi36203=1;
     if vi36213=0 then vi36213=1;
     if vi36223=0 then vi36223=1;

 cons01=vi36015-(vi36014*(vi36015/(a36014*2)))+(vi36013-1)*0.5*a36015;
 cons02=vi36025-(vi36024*(vi36025/(a36024*2)))+(vi36023-1)*0.5*a36025;
 cons03=vi36035-(vi36034*(vi36035/(a36034*2)))+(vi36033-1)*0.5*a36035;
 cons04=vi36045-(vi36044*(vi36045/(a36044*2)))+(vi36043-1)*0.5*a36045;
 cons05=vi36055-(vi36054*(vi36055/(a36054*2)))+(vi36053-1)*0.5*a36055;
 cons06=vi36065-(vi36064*(vi36065/(a36064*2)))+(vi36063-1)*0.5*a36065;
 cons07=vi36075-(vi36074*(vi36075/(a36074*2)))+(vi36073-1)*0.5*a36075;
 cons08=vi36085-(vi36084*(vi36085/(a36084*2)))+(vi36083-1)*0.5*a36085;
 cons09=vi36095-(vi36094*(vi36095/(a36094*2)))+(vi36093-1)*0.5*a36095;
 cons10=vi36105-(vi36104*(vi36105/(a36104*2)))+(vi36103-1)*0.5*a36105;
 cons11=vi36115-(vi36114*(vi36115/(a36114*2)))+(vi36113-1)*0.5*a36115;
 cons12=vi36125-(vi36124*(vi36125/(a36124*2)))+(vi36123-1)*0.5*a36125;
 cons13=vi36135-(vi36134*(vi36135/(a36134*2)))+(vi36133-1)*0.5*a36135;
 cons14=vi36145-(vi36144*(vi36145/(a36144*2)))+(vi36143-1)*0.5*a36145;
 cons15=vi36155-(vi36154*(vi36155/(a36154*2)))+(vi36153-1)*0.5*a36155;
 cons16=vi36165-(vi36164*(vi36165/(a36164*2)))+(vi36163-1)*0.5*a36165;
 cons17=vi36175-(vi36174*(vi36175/(a36174*2)))+(vi36173-1)*0.5*a36175;
 cons18=vi36185-(vi36184*(vi36185/(a36184*2)))+(vi36183-1)*0.5*a36185;
 cons19=vi36195-(vi36194*(vi36195/(a36194*2)))+(vi36193-1)*0.5*a36195;
 cons20=vi36205-(vi36204*(vi36205/(a36204*2)))+(vi36203-1)*0.5*a36205;
 cons21=vi36215-(vi36214*(vi36215/(a36214*2)))+(vi36213-1)*0.5*a36215;
 cons22=vi36225-(vi36224*(vi36225/(a36224*2)))+(vi36223-1)*0.5*a36225;

  if cons01<0 then cons01=0;
  if cons02<0 then cons02=0;
  if cons03<0 then cons03=0;
  if cons04<0 then cons04=0;
  if cons05<0 then cons05=0;
  if cons06<0 then cons06=0;
  if cons07<0 then cons07=0;
  if cons08<0 then cons08=0;
  if cons09<0 then cons09=0;
  if cons10<0 then cons10=0;
  if cons11<0 then cons11=0;
  if cons12<0 then cons12=0;
  if cons13<0 then cons13=0;
  if cons14<0 then cons14=0;
  if cons15<0 then cons15=0;
  if cons16<0 then cons16=0;
  if cons17<0 then cons17=0;
  if cons18<0 then cons18=0;
  if cons19<0 then cons19=0;
  if cons20<0 then cons20=0;
  if cons21<0 then cons21=0;
  if cons22<0 then cons22=0;



    durstock=sum(cons01,cons02,cons03,cons04,cons05,cons06,
               cons07,cons08,cons09,cons10,cons11,cons12,
               cons13,cons14,cons15,cons16,cons17,cons18,
               cons19,cons20,cons21,cons22);

    if durstock=. then durstock=0;

proc sort; by region narea;

proc reg data=work2;
  model rent=
        house
        appart
        room
         stonwal
        adobwal
        woodwal
        plnkflor
        parqflor
        baldflor
        vnylflor
        cmntflor
        caneflor
        numrooms
        bedrooms
        bathroom
        kitchen
        ownkit
         watpub
        wattub
        watlav
        wattru
        permin
        sewage
        septic
        electric


        phone

        shower
        wastdisp
        wastyes
        cookgas
        cooklena
        cookcar
        cookelec

        durstock  / selection=stepwise;
               by region narea;
               output out=out P=prent;
               run;
*/;

data saslib95.vivien;
        set out;
        rentp=prent;
        if rent ne '.' then rentp=rent;
        if rentp<0 then rentp=0;
        keep nhid1 nhid2 rent rentp;

proc print;

run;
quit;
