 libname peter 'c:\ecv95\data\output';

proc format;
 value foodc 301='acelga' 302='ajo' 303='alverja seca'
304='alverja tierna' 305='apio' 306='col' 307='coliflor'
308='cebolla blanca' 309='cebolla paitena' 310='culantro y perejil'
311='choclos' 312='chochos' 313='frejol seco' 314='frejol tierno'
315='garbanzo seco' 316='haba seca' 317='haba tierna' 318='lechuga'
319='lenteja' 320='maiz y morocho' 321='mote' 322='melloco' 323='papas'
324='pepinillos' 325='pimientos' 326='platano maduro'
327='platano verde' 328='rabano' 329='remolacha' 330='tomate rinon'
331='vainita' 332='yuca' 333='zanahoria' 334='aguacate' 335='banano'
336='limon' 337='mandarina' 338='manzana' 339='maracuya'
340='melon' 341='mora' 342='naranja' 343='naranjilla' 344='papaya'
345='pina' 346='tomate de arbol' 347='fideos' 348='galletas'
349='harina de haba' 350='harina de maiz' 351='harina de platano'
352='harina de trigo' 353='machica' 354='quinua' 355='pan'
356='aceite vegetal' 357='arroz' 358='arroz de cebada' 359='avena'
360='azucar' 361='cafe' 362='cereales preparados' 363='cocoa'
364='chocolate' 365='manteca vegetal' 366='manteca de cerdo'
367='mantequilla' 368='margarina' 369='panela' 370='sal'
371='condimentos' 372='sardinas en lata' 373='carne de borrego'
374='carne de chancho' 375='carne suave de res' 376='huevos de gallina'
377='leche liquida' 378='leche en polvo' 379='mortadela'
380='salchichas' 381='pescado fresca' 382='camarones' 383='conchas'
384='pollo entero' 385='presas de pollo' 386='menudencias de pollo'
387='queso' 388='visceras' 389='agua mineral' 390='cerveza' 391='colas'
392='jugos' 393='licores' 394='cigarrillos';


* nhid1 nhid2 foodcd purchase freq quantpur unit expend nonpur ;
* freqnpur valnopur                                            ;

* This program utilizes the sasdata set constructed in usable.prg;

data new1;
  set peter.foodspnd;


* the following weights have been either calculated from units which;
* are identifiable as metric or imperial, or have been based from   ;
* units which are individual items.  These individual item weights  ;
* have been collected from various sources, including documentation ;
* from INEC and INEM, as well as personal calculations using scales ;
* cookbooks, etc.                                                   ;

gram=0;
if unit=27 then gram=1;
if unit=34 then gram=1000;
if unit=36 then gram=454.5;
if unit=38 then gram=1000;
if foodcd=359 and unit=25 then gram=454.5;
if foodcd=361 and unit=24 then gram=600;
if foodcd=308 and unit=82 then gram=61.4;
if foodcd=309 and unit=82 then gram=107;
if foodcd=310 and unit=4 then gram=20;
if foodcd=311 and unit=82 then gram=238;
if foodcd=318 and unit=82 then gram=226;
if foodcd=306 and unit=82 then gram=1100;
if foodcd=325 and unit=82 then gram=74.4;
if foodcd=326 and unit=82 then gram=270;
if foodcd=327 and unit=82 then gram=203;
if foodcd=330 and unit=82 then gram=158;
if foodcd=332 and unit=82 then gram=793;
if foodcd=333 and unit=82 then gram=128;
if foodcd=334 and unit=82 then gram=167;
if foodcd=335 and unit=82 then gram=127;
if foodcd=336 and unit=82 then gram=122;
if foodcd=337 and unit=82 then gram=68;
if foodcd=338 and unit=82 then gram=151;
if foodcd=340 and unit=82 then gram=1100;
if foodcd=342 and unit=82 then gram=182;
if foodcd=343 and unit=82 then gram=65.8;
if foodcd=344 and unit=82 then gram=1613;
if foodcd=345 and unit=82 then gram=1400;
if foodcd=346 and unit=82 then gram=64.1;
if foodcd=348 and unit=52 then gram=70.2;
if foodcd=355 and unit=82 then gram=50;
if foodcd=361 and unit=25 then gram=400;
if foodcd=362 and unit=10 then gram=454.5;
if foodcd=363 and unit=25 then gram=360;
if foodcd=364 and unit=82 then gram=27;
if foodcd=368 and unit=82 then gram=500;
if foodcd=369 and unit=82 then gram=500;
if foodcd=370 and unit=82 then gram=1000;
if foodcd=371 and unit=24 then gram=427;
if foodcd=372 and unit=35 then gram=200;
if foodcd=376 and unit=82 then gram=54.3;
if foodcd=381 and unit=82 then gram=123;
if foodcd=384 and unit=82 then gram=1798.5;
if foodcd=385 and unit=82 then gram=125.1;
if foodcd=387 and unit=82 then gram=500;
if foodcd=389 and unit=10 then gram=1350;
if foodcd=389 and unit=82 then gram=750;
if foodcd=390 and unit=6 then gram=355;
if foodcd=391 and unit=6 then gram=355;
if foodcd=392 and unit=82 then gram=1000;
if foodcd=393 and unit=82 then gram=500;
if foodcd=393 and unit=6 then gram=500;

* The following are fairly wild guesses;

if foodcd=305 and unit=60 then gram=225;
if foodcd=383 and unit=25 then gram=350;

cstgram=0;
if gram ne 0 and expend ne 0 then cstgram=expend/gram;

proc sort;
   by regarea foodcd;

data new2;
  set new1;

if cstgram>0;

proc univariate noprint data=new2;
   var cstgram;
   by regarea foodcd;
output out=peter.modcost1 mode=modcost1;
proc datasets;
   delete new2;
data new3;
   merge new1 peter.modcost1;
   by regarea foodcd;

value=0;
if .<quantpur<98 and .<expend<88887 then value=quantpur*expend;

purfood=value;
if freq=1 then purfood=value*14;
if freq=2 then purfood=value*2;
if freq=3 then purfood=value;
if freq=4 then purfood=value/2;
if freq=5 then purfood=value/6;
if freq=6 then purfood=value/12;

home=0;
if 0<valnopur<99998 then home=valnopur;
homefood=home;
if freqnpur=1 then homefood=home*14;
if freqnpur=2 then homefood=home*2;
if freqnpur=3 then homefood=home;
if freqnpur=4 then homefood=home/2;
if freqnpur=5 then homefood=home/6;
if freqnpur=6 then homefood=home/12;


quant1=0;
if gram>0 and freq=1 then
quant1=(((quantpur*gram)*14)+(homefood))/modcost1;
if gram>0 and freq=2 then
quant1=(((quantpur*gram)*2)+(homefood))/modcost1;
if gram>0 and freq=3 then
quant1=((quantpur*gram)+(homefood))/modcost1;
if gram>0 and freq=4 then
quant1=(((quantpur*gram)/2)+(homefood))/modcost1;
if gram>0 and freq=5 then
quant1=(((quantpur*gram)/6)+(homefood))/modcost1;
if gram>0 and freq=6 then
quant1=(((quantpur*gram)/12)+(homefood))/modcost1;
if gram>0 and freq=7 then
quant1=((quantpur*gram)+(homefood))/modcost1;
if gram=0 then quant1=(purfood+homefood)/modcost1;
proc datasets;
   delete new1;

proc sort;
   by region foodcd;

data new1;
   set new3;

if cstgram>0;

proc univariate noprint;
   var cstgram;
   by region foodcd;
output out=peter.modcost2 mode=modcost2;
proc datasets;
   delete new1;
data new1;
   merge new3 peter.modcost2;
   by region foodcd;

quant2=0;
if quant1<=0 and gram>0 and freq=1 then
quant2=(((quantpur*gram)*14)+(homefood))/modcost2;
if quant1<=0 and gram>0 and freq=2 then
quant2=(((quantpur*gram)*2)+(homefood))/modcost2;
if quant1<=0 and gram>0 and freq=3 then
quant2=((quantpur*gram)+(homefood))/modcost2;
if quant1<=0 and gram>0 and freq=4 then
quant2=(((quantpur*gram)/2)+(homefood))/modcost2;
if quant1<=0 and gram>0 and freq=5 then
quant2=(((quantpur*gram)/6)+(homefood))/modcost2;
if quant1<=0 and gram>0 and freq=6 then
quant2=(((quantpur*gram)/12)+(homefood))/modcost2;
if quant1<=0 and  gram>0 and freq=7 then
quant2=((quantpur*gram)+(homefood))/modcost2;
if quant1<=0 and gram=0 then quant2=(purfood+homefood)/modcost2;

proc datasets;
   delete new3;
proc sort;
   by foodcd;

data new2;
   set new1;

if cstgram>0;
proc univariate noprint;
   var cstgram;
   by foodcd;
output out=peter.modcost3 mode=modcost3;
proc datasets;
   delete new2;


data peter.foodquan;
   merge new1 peter.modcost3;
   by foodcd;

quant3=0;
if quant1<=0 and quant2<=0 and gram>0 and freq=1 then
quant3=(((quantpur*gram)*14)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=2 then
quant3=(((quantpur*gram)*2)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=3 then
quant3=((quantpur*gram)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=4 then
quant3=(((quantpur*gram)/2)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=5 then
quant3=(((quantpur*gram)/6)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=6 then
quant3=(((quantpur*gram)/12)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram>0 and freq=7 then
quant3=((quantpur*gram)+(homefood))/modcost3;
if quant1<=0 and quant2<=0 and gram=0 then quant3=(purfood+homefood)/modcost3;

quantity=0;
if quant1>0 then quantity=quant1;
if quant1<=0 and quant2>0 then quantity=quant2;
if quant1<=0 and quant2<=0 and quant3>0 then quantity=quant3;

if foodcd=394 then delete;
keep nhid1 nhid2 regarea region foodcd quantity modcost1 modcost2 modcost3;

proc univariate noprint;
   var quantity;
   by foodcd;
output out=newdat mean=meanqnt;
data temp;
   set newdat;
proc print;
  var foodcd meanqnt;
format foodcd foodc.;
run;
quit;
