 libname peter 'c:\ecv95\data\output';
/*
proc format;
 value foodc 301='acelga' 302='ajo' 303='alverja seca'
304='alverja tierna' 305='apio' 306='col' 307='coliflor'
308='cebolla blanca' 309='cebolla paitena' 310='culantro y perejil'
311='choclos' 312='chochos' 313='frejol seco' 314='frejol tierno'
315='garbanzo seco' 316='haba seca' 317='haba tierna' 318='lechuga'
319='lenteja' 320='maiz y morocho' 321='mote' 322='melloco' 323='papas'
324='pepinillos' 325='pimientos' 326='platano maduro'
327='platano verde' 328='rabano' 329='remolacha' 330='tomate rinon'
331='vainita' 332='yuca' 333='zanahoria' 334='aguacate' 335='banano'
336='limon' 337='mandarina' 338='manzana' 339='maracuya'
340='melon' 341='mora' 342='naranja' 343='naranjilla' 344='papaya'
345='pina' 346='tomate de arbol' 347='fideos' 348='galletas'
349='harina de haba' 350='harina de maiz' 351='harina de platano'
352='harina de trigo' 353='machica' 354='quinua' 355='pan'
356='aceite vegetal' 357='arroz' 358='arroz de cebada' 359='avena'
360='azucar' 361='cafe' 362='cereales preparados' 363='cocoa'
364='chocolate' 365='manteca vegetal' 366='manteca de cerdo'
367='mantequilla' 368='margarina' 369='panela' 370='sal'
371='condimentos' 372='sardinas en lata' 373='carne de borrego'
374='carne de chancho' 375='carne suave de res' 376='huevos de gallina'
377='leche liquida' 378='leche en polvo' 379='mortadela'
380='salchichas' 381='pescado fresca' 382='camarones' 383='conchas'
384='pollo entero' 385='presas de pollo' 386='menudencias de pollo'
387='queso' 388='visceras' 389='agua mineral' 390='cerveza' 391='colas'
392='jugos' 393='licores' 394='cigarrillos';


nhid1 nhid2 foodcd purchase freq quantpur unit expend nonpur freqnpur
valnopur


data new1;
  set peter.foodcode;

* if value of home produced goods is not available, it is set to 0;

if .<nonpur<5 and valnopur>88887 then valnopur=0;

zed1=int(nhid1/10);
region=int(nhid1/10000000);
zed2=region*1000000;
ciudad=zed1-zed2;
zed3=zed1*10;
area=nhid1-zed3;

nreg=region*10;
regarea=nreg+area;

proc sort;
   by regarea foodcd unit;

data new2;
set new1;

* to impute prices for entries where there is a non-response in the  ;
* dataset, we first calculate average prices, per region,  area and  ;
* quantity unit. We then graft these prices onto the dataset where   ;
* there were originally non-responses. For some foodcode/unit        ;
* combinations, it is not possible to obtain an average price within ;
* a given region and area.  In this case we redo the exercise at the ;
* regional level.  If again, no average price is available for a     ;
* given region, the exercise is repeated at the national level.      ;

if .<expend<=88887;
proc means noprint;
   var expend;
   by regarea foodcd unit;
output out=newdat1 mean(expend)=avprice1;

data new3;
   merge new1 newdat1;
by regarea foodcd unit;

if expend=. or expend>=88887 then expend=avprice1;

proc sort;
   by region foodcd unit;

data new2;
   set new3;
if .<expend<=88887;

proc means noprint;
   var expend;
   by region foodcd unit;
output out=newdat2 mean(expend)=avprice2;

data new1;
   merge new3 newdat2;
by region foodcd unit;
if expend=. or expend>=88887 then expend=avprice2;

proc sort;
   by foodcd unit;

data new2;
   set new1;

if .<expend<=88887;

proc means noprint;
   var expend;
   by foodcd unit;
output out=newdat3 mean(expend)=avprice3;

data peter.foodspnd;
   merge new1 newdat3;
   by foodcd unit;
if expend=. or expend>=88887 then expend=avprice3;

proc sort data=peter.foodspnd;
   by nhid1 nhid2 foodcd;
*/
data new1;
   set peter.foodspnd;

error1=0;
if purchase=1 and freq=. or freq>7 then error1=1;
error2=0;
if purchase=1 and quantpur=. or quantpur=99.99 then error2=1;
if purchase=1 and quantpur>8887 then error2=1;
error3=0;
if purchase=1 and unit=. or unit>87 then error3=1;
error4=0;
if purchase=1 and expend=. or expend>88887 then error4=1;

if .<nonpur<5 and valnopur=. or valnopur>88887 then valnopur=0;

if error1=1 and error2=1 and error3=1 and error4=1 then delete;
if error2=1 and error3=1 and error4=1 then delete;

* there are 48 remaining problem data points.  These will be set ;
* to zero from now on. (and labelled 'problem')                  ;

problem=0;
if error1=1 or error2=1 or error3=1 or error4=1 then problem=1;

value=(quantpur*expend);

if problem=1 then value=0;

purfood=value;
if freq=1 then purfood=value*14;
if freq=2 then purfood=value*2;
if freq=3 then purfood=value;
if freq=4 then purfood=value/2;
if freq=5 then purfood=value/6;
if freq=6 then purfood=value/12;

homefood=valnopur;
if freqnpur=1 then homefood=valnopur*14;
if freqnpur=2 then homefood=valnopur*2;
if freqnpur=3 then homefood=valnopur;
if freqnpur=4 then homefood=valnopur/2;
if freqnpur=5 then homefood=valnopur/6;
if freqnpur=6 then homefood=valnopur/12;

if purfood=. then purfood=0;
if homefood=. then homefood=0;

cigaril=0;
if foodcd=394 and purfood>0 then cigaril=purfood;
if foodcd=394 and homefood>0 then cigaril=homefood;
if foodcd=394 then purfood=0;
if foodcd=394 then homefood=0;

proc means noprint;
   var purfood homefood cigaril;
   by nhid1 nhid2;
output out=newdat sum(purfood homefood cigaril)=foodspnd foodhome
 cigaril;

data peter.hhfoodsp;
   set newdat;
totfood=foodspnd+foodhome;
if totfood=0 then delete;
keep nhid1 nhid2 foodspnd foodhome totfood cigaril;
proc print;
   var nhid1 nhid2 foodspnd foodhome totfood cigaril;
run;
quit;
